/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.LevelTingkat;
import com.portofolio.entity.vo.LevelTingkatId;

@Lazy
@Repository
public interface LevelTingkatDao extends CrudRepository<LevelTingkat, LevelTingkatId> {

	@Cacheable("LevelTingkatDaofindOneBy")
	LevelTingkat findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);

	@Query(QListAll + " and model.namaLevelTingkat like %:namaLevelTingkat% and model.kdLevelTingkatHead is null ")
	@Cacheable("LevelTingkatDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaLevelTingkat") String namaLevelTingkat, Pageable page,
			@Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll
			+ " and model.namaLevelTingkat like %:namaLevelTingkat% and model.kdLevelTingkatHead =:kdLevelTingkatHead  ")
	@Cacheable("LevelTingkatDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaLevelTingkat") String namaLevelTingkat, Pageable page,
			@Param("kdDepartemen") String kdDepartemen, @Param("kdLevelTingkatHead") Integer kdLevelTingkatHead);

	/*
	 * @Query(QListAll + " and model.kdLevelTingkatHead = :kdLevelTingkatHead ")
	 * 
	 * @Cacheable("LevelTingkatDaoFindAllListHead") Page<Map<String, Object>>
	 * findAllList(@Param("kdProfile") Integer kdProfile, Pageable
	 * page, @Param("kdDepartemen") String
	 * kdDepartemen, @Param("kdLevelTingkatHead") Integer kdLevelTingkatHead);
	 */

	@Query(QListAll + " and model.id.kode = :kode")
	@Cacheable("LevelTingkatDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode,
			@Param("kdDepartemen") String kdDepartemen);
	
	@Query("from LevelTingkat model where model.id.kdProfile=:kdProfile and model.kdDepartemen =:kdDepartemen and model.noUrut=:noUrut and kdLevelTingkatHead is null and model.id.kode not in (:kode)")
	LevelTingkat findOneNotInKodeAndUrutNoHead(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode, @Param("kdDepartemen") String kdDepartemen, @Param("noUrut") Integer noUrut);
	
	@Query("from LevelTingkat model where model.id.kdProfile=:kdProfile and model.kdDepartemen =:kdDepartemen and model.noUrut=:noUrut and kdLevelTingkatHead=:kdHead and model.id.kode not in (:kode)")
	LevelTingkat findOneNotInKodeAndUrutHead(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode, @Param("kdDepartemen") String kdDepartemen, @Param("kdHead") Integer kdHead, @Param("noUrut") Integer noUrut);
	
	
	@Query("from LevelTingkat model where model.id.kdProfile=:kdProfile and model.kdDepartemen =:kdDepartemen and model.noUrut=:noUrut and kdLevelTingkatHead is null")
	LevelTingkat findOneUrutNoHead(@Param("kdProfile") Integer kdProfile, @Param("kdDepartemen") String kdDepartemen, @Param("noUrut") Integer noUrut);
	
	@Query("from LevelTingkat model where model.id.kdProfile=:kdProfile and model.kdDepartemen =:kdDepartemen and model.noUrut=:noUrut and kdLevelTingkatHead=:kdHead")
	LevelTingkat findOneUrutHead(@Param("kdProfile") Integer kdProfile, @Param("kdDepartemen") String kdDepartemen, @Param("kdHead") Integer kdHead, @Param("noUrut") Integer noUrut);
	

	String QListAll = "select new map(model.id.kdLevelTingkat as kdLevelTingkat,model.id.kdProfile as kdProfile " + ", model.namaLevelTingkat as namaLevelTingkat "
			+ ", model.reportDisplay as reportDisplay " + ", model.kdLevelTingkatHead as kdLevelTingkatHead "
			+ ", levelTingkatHead.namaLevelTingkat as namaLevelTingkatHead " + ", model.noUrut as noUrut "
			+ ", model.kdDepartemen as kdDepartemen " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal " + ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " + ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from LevelTingkat model left join model.id id " + " left join model.departemen departemen "
			+ " left join model.levelTingkatHead levelTingkatHead "
			+ " where id.kdProfile=:kdProfile and departemen.id.kdProfile=id.kdProfile and model.kdDepartemen =:kdDepartemen ";

	@Query("select new map(model.id.kode as kode , model.namaLevelTingkat as namaLevelTingkat) from LevelTingkat model"
			+ " where model.id.kdProfile=:kdProfile and model.kdLevelTingkatHead = :kode and model.statusEnabled=true  ")
	List<Map<String, Object>> findByHead(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode);

	LevelTingkat findOneByIdKdProfileAndNoUrut(Integer kdProfile, Integer noUrut);
	LevelTingkat findOneByIdKdProfileAndKdLevelTingkatHeadAndNoUrut(Integer kdProfile, Integer kdHead, Integer noUrut);

	LevelTingkat findOneByIdKdProfileAndIdKodeNotAndNoUrut(Integer kdProfile, Integer kode, Integer noUrut);
	
}
